dofile("Base.rte/Constants.lua")
dofile("Base.rte/Actors/AI/HumanAI.lua")

function Create(self)

	self.AI = NativeHumanAI:Create(self)

	--self.jetOn = false;
	self:SetNumberValue("Hoverjet",0);
--	self.jetSwitchTimer = Timer();
--	self.jetSwitchTime = 250;
	self.jumpset = 0;

	
	
	local MoObj
	for i = 1, MovableMan:GetMOIDCount()-1 do
		if MovableMan:GetRootMOID(i) == self.ID then
			MoObj = MovableMan:GetMOFromID(i)
			if MoObj.PresetName == "ArielFlyer Fuel Tank" then
				self.FuelTank = ToAttachable(MoObj)
				break
			end
		end
	end

--	self.soundTimer = Timer();
--	self.soundTime = 1000;

--	self.flash = CreateMOSParticle("PackEffect","EAF.rte");
end

function UpdateAI(self)
   self.AI:Update(self)
end

function Update(self)

	local ownController = self:GetController();
	--[[
	if self.FGArm ~= nil then
		if  (self.EquippedItem == nil) or (self.EquippedItem.PresetName ~= "Vampire") then
			self.FGArm:Detach();
		end
	end
	]]
	if self.FuelTank then
		if self.FuelTank:IsAttached() == false then   -- check if the pointer is safe to access
			--self.Health = 0;
			self.JetTimeLeft = 0;
		end
	end
--[[
	if not(self:IsDead()) then
		if ownController:IsState(Controller.PRESS_DOWN) then
			if self.jetSwitchTimer:IsPastSimMS(self.jetSwitchTime) then
				self.jetSwitchTimer = Timer();
			else
				self.jetOn = not self.jetOn;
			end
		end
	end
]]
	if (self.Health <= 0) or (self.JetTimeLeft < self.JetTimeTotal/5) then
		--self.jetOn = false;
		self:SetNumberValue("Hoverjet",0);
	end

	--if self.jetOn then
	if self:GetNumberValue("Hoverjet") == 1 then
		
--[[		jetFlash = CreateMOSParticle("Jump Jet Glow");
		jetFlash.Pos.Y = self.Pos.Y + 6;
		if not(self.HFlipped) then
			jetFlash.Pos.X = self.Pos.X - 16;
		else 
			jetFlash.Pos.X = self.Pos.X + 16;
		end
		MovableMan:AddParticle(jetFlash);
		]]
		self.jumpset = true;
		
		if ownController:IsState(Controller.HOLD_LEFT) then
			self:AddImpulseForce(Vector(-14,0),Vector(0,0))
		elseif ownController:IsState(Controller.HOLD_RIGHT) then
			self:AddImpulseForce(Vector(14,0),Vector(0,0))
		else
			self.Vel.X = self.Vel.X * 0.7;
			if math.abs(self.Vel.X) < 2 then
				self.Vel.X = 0;
			end
		end

		if ownController:IsState(Controller.HOLD_DOWN) then
		--	self.Vel.Y = self.Vel.Y + 0.2;
			self.jumpset = false;
		elseif ownController:IsState(Controller.HOLD_UP) then
			--self.Vel.Y = self.Vel.Y - 0.2;
		else
			self.Vel.Y = self.Vel.Y * 0.7;
			if math.abs(self.Vel.Y) < 2 then
				self.Vel.Y = 0;
			end
		end
		
		if self.jumpset then
			self:GetController():SetState(Controller.BODY_JUMP,true)
			--[[
			if self.Vel.X > 10  then
				self.Vel.X = 10;
			elseif self.Vel.X < -10 then
				self.Vel.X = -10;
			end

			if self.Vel.Y > 10  then
				self.Vel.Y = 10;
			elseif self.Vel.Y < -10 then
				self.Vel.Y = -10;
			end
			]]
		end



--[[		if self.soundTimer:IsPastSimMS(self.soundTime) then
			self.soundTimer = Timer();
			self.jetSound = CreateAEmitter("Jet sound emmitter");
			self.jetSound.Pos = self.Pos;
			MovableMan:AddParticle(self.jetSound);
		end
		]]
		self.RotAngle = 0;
	end
end

function Destroy(self)
	--self.jetOn = false;
	--self:SetNumberValue("Hoverjet",0);
end

function Toggle(actor)
--[[
	for index,data in pairs(AHumans) do
		if type(data) == "userdata" then
			if data.PresetName == "Ariel Flyer" then
				if SceneMan:ShortestDistance(actor.Pos,data.Pos,true).Magnitude < 10 then
					data.jetOn = not data.jetOn;
				end
			end
		end
	end]]
	--print(actor);
	--print(actor.jetOn)
	actor.jetOn = not actor.jetOn;
	if actor:GetNumberValue("Hoverjet") == 1 then
		actor:SetNumberValue("Hoverjet",0);
	else
		actor:SetNumberValue("Hoverjet",1);
	end
end

