function Create(self)

	self.gotid = self.Sharpness;
	self.bind = false;
	if IsActor(MovableMan:GetMOFromID(self.gotid)) then
		self.owner = ToActor(MovableMan:GetMOFromID(self.gotid));
		if IsActor(self.owner) then
			if ToActor(self.owner):NumberValueExists("Star") ~= true then
				ToActor(self.owner):SetNumberValue("Star",self.UniqueID);
				self.bind = true;
			else
				--ToActor(self.owner):RemoveNumberValue("Star");
				--self:GibThis();
				ToActor(self.owner):SetNumberValue("Star",self.UniqueID);
				self.bind = true;
			end
		else
			self.owner = nil;
		end
	else
		self.owner = nil;
	end
	self.Sharpness = 0;
	self.type = 0;
	self.name = "Fairy";
	self.Frame = math.random(0,3);

end


function Update(self)

	self.Frame = math.random(0,3);
	if IsActor(self.owner) then
		if self.type == 0 then
			if IsAHuman(self.owner) then
				self.type = 1;
				self.name = ToActor(self.owner).PresetName;
			elseif IsACrab(self.owner) then
				self.type = 2;
				self.name = ToActor(self.owner).PresetName;
			else
				self.type = -1;
			end
		end
		if ToActor(self.owner):GetNumberValue("Star") ~= self.UniqueID then
			self:GibThis();
		end
		if self.Team == self.owner.Team then
			--self.Pos = self.owner.Pos;
			--local target = Vector(0,0);
			--if SceneMan:CastObstacleRay(position, Vector(600,0):DegRotate(60), target, Vector(), actor.RootID, team, 128, 1) >= 0 then
			local cood = Vector(0,0);
			local angle = 0;
			if self.owner.HFlipped == true then
				angle = 45;
			else
				angle = 135;
			end
			--print(angle)
			if SceneMan:CastNotMaterialRay(self.owner.Pos, Vector(100,0):DegRotate(angle), 0, cood, 5, false) == true then
				cood = self.owner.Pos + SceneMan:ShortestDistance(self.owner.Pos,cood,true) * 0.7;
			else
				cood = self.owner.Pos + Vector(70,0):DegRotate(angle);
			end
			--FrameMan:DrawLinePrimitive(self.owner.Pos, cood, 0);
			local vec = SceneMan:ShortestDistance(self.Pos, cood, true)
			self.Pos = self.Pos + vec * 0.1;
			self.RotAngle = self.RotAngle + self.AngularVel;
			--self.Scale = self.Scale - 0.001;
		end
		if self.type > 0 then
			if ToActor(self.owner).Health <= 0 then
				--create
				if self.type == 1 then
					local summon = CreateAHuman(self.name);
					summon.Team = self.Team;
					summon.Pos = self.Pos;
					summon.Vel = Vector(0,0);
					if math.random(1,2) == 2 then
						summon.HFlipped = true;
					end
					summon.AIMode = Actor.AIMODE_SENTRY;
					MovableMan:AddActor(summon);
					summon:FlashWhite(200);
					local Effect = CreateAEmitter("NanoCount", "RFS.rte");
					Effect.Pos = summon.Pos;
					--Effect:SetWhichMOToNotHit(actor, 0.1)
					Effect.Team = summon.Team;
					Effect.Sharpness = summon.RootID;
					Effect.IgnoresTeamHits = true;
					--Add the particle to the world.
					MovableMan:AddParticle(Effect);
					local effect = CreateMOSRotating("Warp Grenade Effect", "Techion.rte");
					effect.Pos = self.Pos;
					MovableMan:AddParticle(effect);
					effect:GibThis();
				elseif self.type == 2 then
					local summon = CreateACrab(self.name);
					summon.Team = self.Team;
					summon.Pos = self.Pos;
					summon.Vel = Vector(0,0);
					if math.random(1,2) == 2 then
						summon.HFlipped = true;
					end
					summon.AIMode = Actor.AIMODE_SENTRY;
					MovableMan:AddActor(summon);
					summon:FlashWhite(200);
					local Effect = CreateAEmitter("NanoCount", "RFS.rte");
					Effect.Pos = summon.Pos;
					--Effect:SetWhichMOToNotHit(actor, 0.1)
					Effect.Team = summon.Team;
					Effect.Sharpness = summon.RootID;
					Effect.IgnoresTeamHits = true;
					--Add the particle to the world.
					MovableMan:AddParticle(Effect);
					local effect = CreateMOSRotating("Warp Grenade Effect", "Techion.rte");
					effect.Pos = self.Pos;
					MovableMan:AddParticle(effect);
					effect:GibThis();
				end
				self.name = "Fairy";
				self.type = -1;
				self:GibThis();
			end
		end
	else
		self:GibThis();
	end
	
end

function Destroy(self)

	if IsActor(self.owner) and self.bind == true then
		if ToActor(self.owner):NumberValueExists("Star") == true then
			if ToActor(self.owner):GetNumberValue("Star") == self.UniqueID then
				ToActor(self.owner):RemoveNumberValue("Star");
			end
		end
	end

end