--package.loaded.Constants = nil; require("Constants")
--dofile("AAA.rte/SpellFunctions.lua")

function Create(self)

	self.delayTimer = Timer();
	self.actionPhase = 0;
	self.fireOn = false;

end

function Update(self)

	if self:IsActivated() then

		if self.fireOn == false then
			self.Magazine.RoundCount = 100-self.delayTimer.ElapsedSimTimeMS;
			if self.delayTimer:IsPastSimMS(100) then
				self.delayTimer:Reset();
				self.actionPhase = self.actionPhase + 1;
			end
			if self.actionPhase == 1 then
				if self.ID ~= self.RootID then
					local actor = MovableMan:GetMOFromID(self.RootID);
					if IsActor(actor) then
						local Effect = CreateAEmitter("Nanofairy", "RFS.rte");
						Effect.Pos = actor.Pos;
						--Effect:SetWhichMOToNotHit(actor, 0.1)
						Effect.Team = actor.Team;
						Effect.Sharpness = actor.RootID;
						Effect.IgnoresTeamHits = true;
						--Add the particle to the world.
						MovableMan:AddParticle(Effect);
						self:GibThis();
					end
				end
				self.fireOn = true;
			end
		end
	else
		self.delayTimer:Reset();
		self.Magazine.RoundCount = 100;
		self.fireOn = false;
		self.actionPhase = 0;
	end

end

function Destroy(self)

end