function Create(self)
--remote grenade
	self.actionPhase = 0;
	self.stuck = false;
	self.lifeTimer = Timer();

end

function Update(self)

	if self.Sharpness == 0 then --default state
		self.ToDelete = false; --don't delete
		self.ToSettle = false; --don't settle
	elseif self.Sharpness == 1 then --if delete state
		self.ToDelete = true; --set delete
	elseif self.Sharpness == 2 then --if detonate state
		self.Vel.X = self.Vel.X*100;
		self.Vel.Y = self.Vel.Y*100;
		self.Sharpness = 25;
		self.HitsMOs = true;
	elseif self.Sharpness == 3 then --AI state
		if self.lifeTimer:IsPastSimMS(3000) then --lol AI just get timed nades
			self.Vel.X = self.Vel.X*100;
			self.Vel.Y = self.Vel.Y*100;
			self.Sharpness = 25;
			self.HitsMOs = true;
		else --not yet time
			self.ToDelete = false; --don't delete
			self.ToSettle = false; --don't settle
		end
	end
--[[
	if self.actionPhase == 0 then --if freemove state
		local rayHitPos = Vector(0,0);
		local rayHit = false;
		for i = 1, 15 do
			local checkPos = self.Pos + Vector(self.Vel.X,self.Vel.Y):SetMagnitude(i);
			local checkPix = SceneMan:GetMOIDPixel(checkPos.X,checkPos.Y);
			if checkPix ~= 255 then
				checkPos = checkPos + SceneMan:ShortestDistance(checkPos,self.Pos,SceneMan.SceneWrapsX):SetMagnitude(3);
				self.target = MovableMan:GetMOFromID(checkPix);
				self.stickpositionX = checkPos.X-self.target.Pos.X;
				self.stickpositionY = checkPos.Y-self.target.Pos.Y;
				self.stickrotation = self.target.RotAngle;
				self.stickdirection = self.RotAngle;
				self.stuck = true;
				rayHit = true;
				break;
			end
		end
		if rayHit == true then --if ray hit
			self.actionPhase = 1;--sticky state
		else --if ray not hit
			if SceneMan:CastStrengthRay(self.Pos,Vector(self.Vel.X,self.Vel.Y):SetMagnitude(15),0,rayHitPos,0,0,SceneMan.SceneWrapsX) == true then
				self.Pos = rayHitPos + SceneMan:ShortestDistance(rayHitPos,self.Pos,SceneMan.SceneWrapsX):SetMagnitude(3);
				self.PinStrength = 1000;
				self.AngularVel = 0;
				self.stuck = true;
				self.actionPhase = 2; --some other state
				self.HitsMOs = false;
			end
		end
	elseif self.actionPhase == 1 then --if sticky state
		if self.target ~= nil and self.target.ID ~= 255 then
			self.Pos = self.target.Pos + Vector(self.stickpositionX,self.stickpositionY):RadRotate(self.target.RotAngle-self.stickrotation);
			self.RotAngle = self.stickdirection+(self.target.RotAngle-self.stickrotation);
			self.PinStrength = 1000;
			self.Vel = Vector(0,0);
			self.HitsMOs = false;
		else
			self.PinStrength = 0;
			self.actionPhase = 0; --set freemove state
			self.HitsMOs = true;
		end
	end
]]
end