
dofile("Base.rte/Constants.lua")
require("Actors/AI/NativeCrabAI")

function Create(self)
	self.AI = NativeCrabAI:Create(self)
	self.hang = false;
	self.hangTimer = Timer();
end

function Update(self)

	if self:IsPlayerControlled() and self:GetController():IsState(Controller.HOLD_DOWN) then
		if self.hangTimer:IsPastSimMS(1000) then
			self.hang = not self.hang;
			self.hangTimer:Reset();
		end
	else
		self.hangTimer:Reset();
	end			
	
	if self.hang then
		self.RotAngle = math.pi;
		self.Vel = self.Vel - (SceneMan.GlobalAcc * self.GlobalAccScalar * TimerMan.DeltaTimeSecs);
		self.Vel = self.Vel - (SceneMan.GlobalAcc * self.GlobalAccScalar * TimerMan.DeltaTimeSecs);
	else
		self.RotAngle = 0;
	end

end

function UpdateAI(self)
	self.AI:Update(self)
end

function Destroy(self)

end
