function Create(self)
	self.range = 0;
	self.maxrange = 450;
	self.guideParPos = Vector(0,0);
	ray = 0;
	self.delayTimer = Timer();
	
	self.ScanTimer = Timer();
	self.scanDelay = 200;
	self.maxScanRange = 450;
	self.scanDisruption = 250;
	self.scanSpacing = 10;

	self.numberOfScans = 2;
	self.scanSpreadAngle = 30; -- Degrees!
	
end

function Update(self)
    if self.Magazine then --have mag
		if self:IsActivated() then
			self.range = math.min(self.delayTimer.ElapsedSimTimeMS * 0.4,self.maxrange);
			--self.range = math.min(self.range+1,self.maxrange);
			--self.range = math.min(self.range + (self.maxrange + 50 - self.range)*0.01,self.maxrange);
			local actor = MovableMan:GetMOFromID(self.RootID);
			if MovableMan:IsActor(actor) and ToActor(actor):IsPlayerControlled() and ToActor(actor):GetController():IsState(Controller.AIM_SHARP) then
				local actor = ToActor(actor);
				self.guideParPos = self.MuzzlePos + Vector(self.range,0):RadRotate(actor:GetAimAngle(true));
				local VectorRel = Vector(self.range,0):RadRotate(actor:GetAimAngle(true));--:GetXFlipped(self.HFlipped))
				ray = SceneMan:CastObstacleRay(self.MuzzlePos, VectorRel, self.guideParPos, Vector(0,0), self.RootID, self.Team, 0, 1);
				if ray >= 0 then
					self.range = ray;
				end
				if self.range < 120 then
					FrameMan:DrawCirclePrimitive(self.guideParPos,math.min(12,self.range*0.1),13);
				else
					FrameMan:DrawCirclePrimitive(self.guideParPos,math.min(12,self.range*0.1),160);
				end
			end
		else
			if self.range >= 120 then
				local actor = MovableMan:GetMOFromID(self.RootID);
				--print(actor);
				if IsAHuman(actor) and ToActor(actor):IsPlayerControlled() == true then
					--ToActor(actor):GetController():SetState(Controller.WEAPON_FIRE,false);
					if ToAHuman(actor):EquipThrowable(true) then
						--print(ToAHuman(actor).EquippedItem);
						local name = ToAHuman(actor).EquippedItem.PresetName;
						--print(name);
						--print(ToAHuman(actor).EquippedItem.ClassName);
						ToAHuman(actor):EquipNamedDevice("Bomb Teleporter",true)
						--print(ToAHuman(actor).EquippedItem);
						ToAHuman(actor):RemoveInventoryItem(name);
						
						local effect = CreateMOSRotating("Warp Grenade Effect", "Techion.rte");
						effect.Pos = self.guideParPos;
						MovableMan:AddParticle(effect);
						effect:GibThis();
						local bomb = CreateTDExplosive(name);
						bomb.Pos = self.guideParPos;
						bomb.Vel = Vector(0,0);
						bomb.Team = actor.Team;
						bomb.RotAngle = math.pi*2*math.random();
						MovableMan:AddParticle(bomb);
						ToTDExplosive(bomb):Activate();
						ToAHuman(actor):ReloadFirearm();
					end
				end
				self.range = 0;
			elseif self.range == 0 then
				if self.ScanTimer:IsPastSimMS(self.scanDelay) then
					self.ScanTimer:Reset();
					local actor = MovableMan:GetMOFromID(self.RootID);
					if MovableMan:IsActor(actor) then
						self.parent = ToActor(actor);
						if self.HFlipped == false then
							self.negativeNum = 1;
						else
							self.negativeNum = -1;
						end
						for x = 1, self.numberOfScans do
							local angleVariance = (-self.scanSpreadAngle*0.5) + (math.random()*self.scanSpreadAngle);
							local terrHitCount = 0;
							local dots = math.floor(self.maxScanRange/self.scanSpacing)
							for i = 1, dots do
								local checkPos = self.MuzzlePos + Vector((self.scanSpacing*i)*self.negativeNum,0):RadRotate(self.RotAngle):DegRotate(angleVariance);
								if SceneMan.SceneWrapsX == true then
									if checkPos.X > SceneMan.SceneWidth then
										checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
									elseif checkPos.X < 0 then
										checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
									end
								end
								local terrCheck = SceneMan:GetTerrMatter(checkPos.X,checkPos.Y);
								if terrCheck ~= 0 then
									terrHitCount = terrHitCount + 1;
								end
							end
							local scanLength = math.floor((self.maxScanRange-(self.scanDisruption*(terrHitCount/dots)))/self.scanSpacing);
							for i = 1, scanLength do
								local checkPos = self.MuzzlePos + Vector((self.scanSpacing*i)*self.negativeNum,0):RadRotate(self.RotAngle):DegRotate(angleVariance);
								if SceneMan.SceneWrapsX == true then
									if checkPos.X > SceneMan.SceneWidth then
										checkPos = Vector(checkPos.X - SceneMan.SceneWidth,checkPos.Y);
									elseif checkPos.X < 0 then
										checkPos = Vector(SceneMan.SceneWidth + checkPos.X,checkPos.Y);
									end
								end
								SceneMan:RevealUnseen(checkPos.X,checkPos.Y,self.parent.Team);
							end
						end
					end
				end
			end
			self.delayTimer:Reset();
			self.range = 0;
		end
	end
	

end

function Destroy(self)


end