function Create(self)
	if self.Magazine then --have mag
		self.ammo = self.Magazine.RoundCount --have ammo
	else--no mag
		self.ammo = 0 --no ammo
	end
	
	self.laserTimer = Timer();
	self.particleTable = {};

	self.projectileVel = 70;
	self.maxTrajectoryPars = 10;
	
	
end

function Update(self)
	if self.Magazine then --have mag
		if self.ammo > self.Magazine.RoundCount then
			-- bullets are missing from the magazine so the gun must have been fired
			
			local Parent = MovableMan:GetMOFromID(self.RootID) --get thing holding gun and store as parent
			--local BulletVel = self.Vel + self:RotateOffset(Vector(170,RangeRand(-3,3))) --set bullet velocity adnd direction
			
			-- bullets
			if self.HFlipped == false then
				self.negativeNum = 1;
			else
				self.negativeNum = -1;
			end
			
			local Target = Vector(0,0);
			local Effect = CreateAEmitter("WaveCannon Head");
			Effect.Pos = self.Pos;
			Effect.Vel = Vector(20*self.negativeNum,0):RadRotate(self.RotAngle);
			Effect:SetWhichMOToNotHit(Parent, 0.1)
			if MovableMan:IsActor(Parent) then
				Effect.Team = ToActor(Parent).Team;
				Effect.IgnoresTeamHits = true;
			end
			MovableMan:AddParticle(Effect)
		end
		
		-- update the ammo counter so this script can't spawn bullets until the gun has been fired again
		self.ammo = self.Magazine.RoundCount
	end
	
	
	
	
end
