function Create(self)

	self.delayTimer = Timer();
	self.overallTimer = Timer();
	self.burstTimer = Timer();
	self.actionPhase = 0;
	self.alliedTeam = -1;
	self.shotnumber = 0;
	self.tracer = 0;

end

function Update(self)

	--print(self.overallTimer.ElapsedSimTimeMS)
	--print(self.delayTimer.ElapsedSimTimeMS)
	if self.ID ~= self.RootID then
		local actor = MovableMan:GetMOFromID(self.RootID);
		if MovableMan:IsActor(actor) then
			self.alliedTeam = ToActor(actor).Team;
		end
	end

	if self.actionPhase == 0 then
		if self:IsActivated() then
			--self.Magazine.RoundCount = 500-self.overallTimer.ElapsedSimTimeMS;
			--if self.delayTimer:IsPastSimMS(500) then
				self.delayTimer:Reset();
				self.actionPhase = self.actionPhase + 1;
				self.overallTimer:Reset();
				self.Magazine.RoundCount = 2500;
				--self.blink = false;
				local soundfx = CreateAEmitter("Digger Sound Activate");
				soundfx.Pos = self.Pos;
				MovableMan:AddParticle(soundfx);
			--end
		else
			self.delayTimer:Reset();
			self.overallTimer:Reset();
			self.Magazine.RoundCount = 2500;
			self.actionPhase = 0;
		end
	elseif self.actionPhase >= 1 then
		--actionPhase = 1 + tonumber(self.delayTimer:IsPastSimMS(1000)) + tonumber(self.delayTimer:IsPastSimMS(2000))
		
		if self.burstTimer:IsPastSimMS(12) then
			self.shotnumber = self.shotnumber + 1;
			if self.shotnumber >= 50 then
				self.shotnumber = 0;
				self.tracer = 1;
			end
			if self.actionPhase + self.tracer == 1 then
				for i = 1, 4 do
					Effect = CreateMOPixel("Particle Light Digger", "Base.rte")
					if Effect then
						Effect.Vel = self.Vel + self:RotateOffset(Vector(90 + math.random() * 10,0)):DegRotate(-25 + math.random()*50)--self:RotateOffset(Vector(90 + math.random() * 10,0):RadRotate(self.RotAngle):DegRotate(-25 + math.random()*50))
						Effect.Pos = self.Pos
						Effect:SetWhichMOToNotHit(self, 0.1)
						Effect.Team = self.alliedTeam;
						Effect.IgnoresTeamHits = true;
						MovableMan:AddParticle(Effect)
					end
				end
			elseif self.actionPhase + self.tracer == 2 then
				for i = 1, 4 do
					Effect = CreateMOPixel("Particle Medium Digger", "Base.rte")
					if Effect then
						Effect.Vel = self.Vel + self:RotateOffset(Vector(90 + math.random() * 10,0)):DegRotate(-25 + math.random()*50)
						Effect.Pos = self.Pos
						Effect:SetWhichMOToNotHit(self, 0.1)
						Effect.Team = self.alliedTeam;
						Effect.IgnoresTeamHits = true;
						MovableMan:AddParticle(Effect)
					end
				end
			elseif self.actionPhase + self.tracer == 3 then
				for i = 1, 4 do
					Effect = CreateMOPixel("Particle Heavy Digger", "Base.rte")
					if Effect then
						Effect.Vel = self.Vel + self:RotateOffset(Vector(90 + math.random() * 10,0)):DegRotate(-25 + math.random()*50)
						Effect.Pos = self.Pos
						Effect:SetWhichMOToNotHit(self, 0.1)
						Effect.Team = self.alliedTeam;
						Effect.IgnoresTeamHits = true;
						MovableMan:AddParticle(Effect)
					end
				end
			elseif self.actionPhase + self.tracer == 4 then
				for i = 1, 4 do
					Effect = CreateMOPixel("Particle Very Heavy Digger", "Base.rte")
					if Effect then
						Effect.Vel = self.Vel + self:RotateOffset(Vector(90 + math.random() * 10,0)):DegRotate(-25 + math.random()*50)
						Effect.Pos = self.Pos
						Effect:SetWhichMOToNotHit(self, 0.1)
						Effect.Team = self.alliedTeam;
						Effect.IgnoresTeamHits = true;
						MovableMan:AddParticle(Effect)
					end
				end
			end
			self.tracer = 0;
			self.burstTimer:Reset();
			self.Magazine.RoundCount = self.Magazine.RoundCount - 1;
			if self.actionPhase == 1 and self.Magazine.RoundCount <= 2000 then
				self.actionPhase = 2;
			end
			if self.actionPhase == 2 and self.Magazine.RoundCount <= 500 then
				self.actionPhase = 3;
			end
		end
			

		
		if self.Magazine.RoundCount <= 0 then
			self:GibThis();
		end
	end

end



				
				