function Create(self)
	self.LifeTimer = Timer();
	self.StunTimer = Timer();
	self.SpazTimer = Timer();
	self.target = nil;
	self.stickpositionX = 0;
	self.stickpositionY = 0;
	self.stickrotation = 0;
	self.stickdirection = 0;

	self.stundelay = 500; -- delay before stunning (MS)
	self.stuntime = 40000; -- how long target is stunned (MS)
	self.spazdelay = 100; -- amount of time between spazing (MS)
	
	self.alliedTeam = -1;

end

function Update(self)

	if self.ID ~= self.RootID then
		local actor = MovableMan:GetMOFromID(self.RootID);
		if MovableMan:IsActor(actor) then
			self.alliedTeam = ToActor(actor).Team;
			--self.actorAngle = ToActor(actor):GetAimAngle(true);
		end
	end

   if self.target == nil then
    if self.LifeTimer:IsPastSimMS(40000) then
		self.ToDelete = true;
    end
		self.stickobject = SceneMan:CastMORay(self.Pos,Vector(5,0):RadRotate(self.RotAngle),255,self.alliedTeam,0,false,0);
    if self.stickobject ~= 255 then --target is actor, notdead
		self.target = MovableMan:GetMOFromID(self.stickobject);
		self.stickpositionX = self.Pos.X-self.target.Pos.X;
		self.stickpositionY = self.Pos.Y-self.target.Pos.Y;
		self.stickrotation = self.target.RotAngle;
		self.stickdirection = self.RotAngle;
		self.startflipped = self.target.HFlipped;
		self.StunTimer:Reset();
    end
   elseif self.target ~= nil and self.target.ID ~= 255 then
	self.ToDelete = false;
	self.ToSettle = false;
	self.Pos = self.target.Pos + Vector(self.stickpositionX,self.stickpositionY):RadRotate(self.target.RotAngle-self.stickrotation);
	self.RotAngle = self.stickdirection+(self.target.RotAngle-self.stickrotation);
	self.Vel = Vector(0,0);
	self.PinStrength = 1000;

    if self.LifeTimer:IsPastSimMS(self.stuntime) then --stun time passed

     if MovableMan:IsActor(self.actor) then --is attached thing a actor
	  self.ToDelete = true; -- delete dart
     end

    end
	self.actor = MovableMan:GetMOFromID(self.target.RootID);

    if MovableMan:IsActor(self.actor) then --is attached thing a actor 
     if self.StunTimer:IsPastSimMS(self.stundelay) then --passed stundelay
      if self.SpazTimer:IsPastSimMS(self.spazdelay) then -- passed spazdelay
--	   if ToActor(self.actor).Health < 99 then
			ToActor(self.actor).Health = math.min(ToActor(self.actor).Health+1,100);
--		   ToActor(self.actor):AddHealth(1);
--	   end
	   self.SpazTimer:Reset(); -- reset spaztimer
      end
     end
	
    end
   elseif self.target ~= nil and self.target.ID == 255 then --actor dead?
	self.ToDelete = true;
   end

end