function Create(self)
	self.alliedTeam = -1;
	--self.actorAngle = -1;
end

function Update(self)
	if self.ID ~= self.RootID then
		local actor = MovableMan:GetMOFromID(self.RootID);
		if MovableMan:IsActor(actor) then
			self.alliedTeam = ToActor(actor).Team;
			--self.actorAngle = ToActor(actor):GetAimAngle(true);
		end
	end
	
	if self:IsActivated() then
		self.ToSettle = false;
		
		for actor in MovableMan.Actors do
			if actor.Team ~= self.alliedTeam then
				local distcheck = SceneMan:ShortestDistance(self.Pos,actor.Pos,true).Magnitude
				if distcheck < 20 then
					self:GibThis()
					break
				end
			end
		end
		SceneMan:RevealUnseen(self.Pos.X,self.Pos.Y,self.alliedTeam);
		--[[
		-- bullets
		for i = 1, 4 do
			Effect = CreateMOPixel("Particle Very Heavy Digger", "Base.rte")
			if Effect then
				Effect.Vel = self.Vel + self:RotateOffset(Vector(95,RangeRand(-180,180)))
				Effect.Pos = self.Pos
				Effect:SetWhichMOToNotHit(self, 0.1)
				Effect.Team = self.alliedTeam;
				Effect.IgnoresTeamHits = true;
				MovableMan:AddParticle(Effect)
			end
		end
]]

--		local rayHitPos = Vector(0,0);
--		if self:GetController():IsState(Controller.BODY_JUMP) and SceneMan:CastStrengthRay(self.Pos,Vector(0,(self.Radius+5)),0,rayHitPos,0,0,SceneMan.SceneWrapsX) == true then
--			self.Vel = self.Vel + Vector(0,-2);
--		end
	end
end